package org.smtose.shadowedhorizons.test;
import org.smtose.shadowedhorizons.environment.*;
import org.smtose.shadowedhorizons.metaobject.*;

//A vulcan test of the environment system
public class EnvironmentTest {
	public static void main(String[] args) {
		MetaAdapter mm = new MetaAdapter();
		MetaAdapter mm2 = new MetaAdapter();
		BoundedEnv env = new BoundedEnv(20,20);
		BoundedEnv env2 = new BoundedEnv(25,25);
		mm.setLocation(3,2);
		mm2.setGeometricLocation(2,3);
		System.out.println("mm = " + mm.getLocation());
		System.out.println("mm2 = " + mm2.getLocation());
		if (mm.getLocation().equals(mm2.getLocation()))
			System.out.println("mm was set at row 3, column 2.  mm2 was set at x = 2, y = 3.  As far as the program sees this, these are equal");
		System.out.println("mm x value: " + mm.getLocation().getX() + "  mm y value: " + mm.getLocation().getY() + "  mm row: " +
			         	            mm.getLocation().row() + "  mm column: " + mm.getLocation().col());
		mm.setEnvironment(env, mm.getLocation());
		System.out.println("You can see that at row 3, column 2, mm was added: " + env.objectAt(new Location(3,2)));
		Location oldLoc = mm.getLocation(); //we store the old location of mm
		mm.setLocation(5,9); // We set the location of mm to row 5, column 9
		env.recordMove(mm,oldLoc); //We specify the old location of mm so it can be removed from record.
		System.out.println("Old loc is cleared: (" + env.objectAt(oldLoc) + ") and mm is now at: " + env.objectAt(mm.getLocation()).getLocation());

		System.out.println("And here we have some friends at: " + env.neighborsOf(mm.getLocation())); //Showing all the neighboring cells to 5,9
		mm.setEnvironment(env2, mm.getLocation());
		System.out.println("Lets move to to a more spacious environment with " + mm.getEnvironment().numRows() + " rows.");
		System.out.println("As you can see, we are no longer in our starting environment because a quick isInEnv() check shows: " + env.isInEnv(mm));
		System.out.println("The same isInEnv() check on our current environment yields: " + env2.isInEnv(mm));
		System.out.println("Now that we are playing with some more powerful functions, lets try some entry points");
		env2.setNamedPoint("North",new Location(0,5));
		System.out.println("We've set the _North_ named point to 0,5 so lets check it: " + env2.getNamedPoint("North"));
		env.setNamedPoint("Town Center",new Location(3,3));
		System.out.println("lets move mm2 to the Town Center of env");
		mm2.setLocation(env.getNamedPoint("Town Center"));
		mm2.setEnvironment(env,mm2.getLocation());
		System.out.println("You can see that at (3,3) Town Center Entry point, mm2 has been added: " + env.objectAt(env.getNamedPoint("Town Center")) );

		
		
	}
			
}
		

