/** 
 * 
 * Shadowed Horizons Software Development Kit:
 * The PortalTest class is copyright(c) 2004 smtose.org
 * This class is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 * 
 * This class is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */
package org.smtose.shadowedhorizons.test;
import org.smtose.shadowedhorizons.metaobject.MetaAdapter;
import org.smtose.shadowedhorizons.environment.BoundedEnv;
import org.smtose.shadowedhorizons.environment.Environment;
import org.smtose.shadowedhorizons.environment.Location;
import org.smtose.shadowedhorizons.world.Portal;

public class PortalTest {

	public static void main(String[] args) {
		//Generating Environments
		Environment env1 = new BoundedEnv(20, 20); 
		Environment env2 = new BoundedEnv(25, 25);

		//Creating a meta object to work with
		MetaAdapter meta = new MetaAdapter();

		//Setting the object's environment and location
		meta.setEnvironment(env1, new Location(2,5));
			
		System.out.println("Your original environment's numRows(): "
				   + meta.getEnvironment().numRows() );
		System.out.println("Your original location: "
				   + meta.getLocation() );
		
		//Creating a named point labeled "Sample" @ (5,4)
		env2.setNamedPoint("Sample",new Location(5,4));

		//Creating a portal pointing to the "Sample" label in env2
		Portal thePortal = new Portal(env2, "Sample");
		
		//Letting the portal move meta to the destination and entry point
		thePortal.interact(meta);

		System.out.println("Your new environment's numRows(): "
				  + meta.getEnvironment().numRows() );
		System.out.println("Your new location: "
				   + meta.getLocation() );

	}
}

