/** 
 * 
 * Shadowed Horizons Software Development Kit:
 * The WorldTest class is copyright(c) 2004 smtose.org
 * This class is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 * 
 * This class is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

package org.smtose.shadowedhorizons.test;
import org.smtose.shadowedhorizons.environment.*;
import org.smtose.shadowedhorizons.world.*;
import org.smtose.shadowedhorizons.metaobject.*;

public class WorldTest {
	public static void main(String[] args) {
		String[] keys = new String[] { "Env1","Env2","Env3","Env4" };
		Environment[] environments = new Environment[] { new BoundedEnv(10,10), //Env1
		                                                 new BoundedEnv(15,15), //Env2
								 new BoundedEnv(20,20), //Env3
								 new BoundedEnv(25,25)  //Env4
							       };
		World thisWorld = new World(keys,environments);
			
		thisWorld.setCurrentEnvironment("Env3");	
			
		System.out.println("The current environment has: " + thisWorld.getCurrentEnvironment().numRows() + " rows");
		System.out.println("Env1 has " + thisWorld.getEnvironment("Env1").numRows() + " rows");
		System.out.println("The statement Env4 is in the World is: " + thisWorld.isInWorld("Env4"));
		System.out.println("The statement Env5 is in the World is: " + thisWorld.isInWorld("Env5"));
	}
}
